 
/*********************************************************************************
 *  Copyright© 2010 Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#ifndef OBJECTIVEFUNCTION_H
#define OBJECTIVEFUNCTION_H

#include <iostream>
#include "BinaryInstance.h"

/* This abstract class defines a superclass for each objective functions. Every object that inherits from
 * this class must implement its virtual function f, representig the fitness function.*/

using namespace std;

class ObjectiveFunction {
protected:
	int _size;
public:
        ObjectiveFunction(int size);
        virtual ~ObjectiveFunction();
        
	virtual double f(BinaryInstance *bi) = 0;
	unsigned int getSize();
};

#endif
