 
/*********************************************************************************
 *  Copyright© 2010 Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#ifndef PBIL_H_
#define PBIL_H_ 

#include "UnivariateEDA.h"

using namespace std;

/* This class defines the implementation of the Population-based Incremental Learning algorithm. */

class PBIL : public UnivariateEDA {
	protected:
		double _gamma;			/* Learning rate. 				*/
	public:
		PBIL(unsigned int popSize, double gamma, const gsl_rng* rnd);
		PBIL(unsigned int popSize, vector<double> prob, double gamma, const gsl_rng* rnd);
		virtual ~PBIL();

		void estimation();
		string getName();

};
#endif
