
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/

#ifndef UNIVARIATEDEUM_H_
#define UNIVARIATEDEUM_H_

#include "DEUM.h"

using namespace std;

/* This class defines the univariate DEUM algorithm with an underlying univariate probabilistic model. */
 
class UnivariateDEUM : public DEUM {

	public:
		UnivariateDEUM(unsigned int pop_size, double cooling_rate, int sampler_iterations, const gsl_rng* rnd);
		virtual ~UnivariateDEUM();

		string getName();
	
	private: 		
		void setupStructure();
};
#endif
