
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    	 *	
 *********************************************************************************/
 
#ifndef HCCOMIT_H_
#define HCCOMIT_H_

#include "COMIT.h"

using namespace std;

/* This class defines a concrete implementation of the algorithm COMIT with an hill-climber fast-search 
 * operator. */

class hcCOMIT : public COMIT {
		double _mut_rate; 
		int _patience;
		
	public:
		hcCOMIT(unsigned int popSize, unsigned int samples, unsigned int max_influence, unsigned int patience, double mut_rate, const gsl_rng* rnd);
		virtual ~hcCOMIT();
		
		void selection();
		void fastsearch();
		
		string getName();
	
	private:
		BinaryInstance* mutate(BinaryInstance* best_individual);
};

#endif
