
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.    		 *	
 *********************************************************************************/

#ifndef PBILCOMIT_H_
#define PBILCOMIT_H_

#include "COMIT.h"

using namespace std;

/* This class defines a concrete implementation of the algorithm COMIT with a PBIL-based fast-search 
 * operator. */
 
class pbilCOMIT : public COMIT {
	double _gamma;
	double _mut_rate;
	int _percentage_selection;
	int _iterations;
	vector<double> _prob; 
	
	public:
		pbilCOMIT(unsigned int popSize, unsigned int samples, unsigned int max_influence, double gamma, double mut_rate, int percentage_selection, int iterations, const gsl_rng* rnd);
		virtual ~pbilCOMIT();
		
		void selection();
		void fastsearch();
		
		string getName();
		
};
#endif
