 
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it),	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#ifndef PBILDECORATOR_H
#define PBILDECORATOR_H

#include "AlgorithmDecorator.h"
#define PBILFN "PBIL.dat"

using namespace std; 

/* This class defines the decorator for the PBIL algorithm. */

class PBILDecorator : public AlgorithmDecorator { 

public:
        PBILDecorator(Glib::ustring &title);
        virtual ~PBILDecorator();
        
        virtual Solver* newInstance(ObjectiveFunction *task, unsigned int algorithmsNum, gsl_rng *r);

private: 
	virtual void initContent();
};

#endif
