 
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)       * 
 *                  Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#include "F3Deceptive.h"
#include <math.h>
/* Class constructor. */
F3Deceptive::F3Deceptive(int size) : ObjectiveFunction(size) {

}

/* Class destructor. */
F3Deceptive::~F3Deceptive() {

}

/* Fitness function. */
double F3Deceptive::f(BinaryInstance *bi) {
	int i, len, sum; 
	double normalize; 
	volatile double retValue = 0; 
	
	if (_size % 3 == 0) { normalize = _size / 3; }
	else if (_size % 3 == 1) { 
		normalize = (floor((double) _size / 3.0) + 0.9); 
		if (bi->get(_size - 1) == 1) retValue = 0.8;
		else retValue = 0.9;
	} else {
		int tmp; 
		normalize = (floor((double) _size / 3.0) + 0.9); 
		tmp = bi->get(_size - 1) + bi->get(_size - 2);
		if (tmp == 1) retValue = 0.8;
		else if (tmp == 0) retValue = 0.9;
	}
	
	len = floor((double) _size / 3) * 3; 
	for (i = 0; i < len; i = i + 3) {
		sum = 0;
		sum += (int)bi->get(i);
		sum += (int)bi->get(i + 1);
		sum += (int)bi->get(i + 2);
		if (sum == 0) { retValue += 0.9; }
		else if (sum == 1) { retValue += 0.8; }
		else if (sum == 3) { retValue += 1.0; }
	}
	
	retValue = retValue / normalize * 100;
	bi->setFitnessCache(retValue);
	return retValue;
}
		
