 
/*********************************************************************************
 *  Copyright© 2010 Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#include "F3DeceptiveOverlapping.h"

/* Class constructor. */
F3DeceptiveOverlapping::F3DeceptiveOverlapping(int size) : ObjectiveFunction(size) {

}

/* Class destructor. */
F3DeceptiveOverlapping::~F3DeceptiveOverlapping() {

}

/* Fitness function. */
double F3DeceptiveOverlapping::f(BinaryInstance *bi) {
	if (bi!=NULL) {
		if(!(bi->validCache())) { 
			/* Fitness cache value not valid */
			double sum = 0;
			for (int j=0; j<_size-2; j=j+2) {
				int s = 0;
				s+= (int)bi->get(j);
				s+= (int)bi->get(j+1);
				s+= (int)bi->get(j+2);
				if (s==0)
					sum+=0.9;
      				else if (s==1)
					sum+=0.8;
      				else if (s==3)
					sum+=1;
			}
			
			volatile double returnValue;
			if (_size % 2 == 0)
				returnValue = ((double)sum)/((_size - 1)/2.0 - 0.5)*100.0;
			else
				returnValue = ((double)sum)/((_size - 1)/2.0)*100.0;
			bi->setFitnessCache(returnValue);
			return returnValue;
		} else {
			return bi->getFitnessCache();
		}
	} else {
		cerr << "[F3DeceptiveOverlapping::f] binary instance cannot be null" << endl;
		return 0;
	}
}
