 
/*********************************************************************************
 *  Copyright© 2010 Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#ifndef FOURPEAKS_H
#define FOURPEAKS_H

#include "ObjectiveFunction.h"

/* This class defines the Four Peaks objective function. */

class FourPeaks : public ObjectiveFunction {
		int t_;
public:
        FourPeaks(int size, int t);
        virtual ~FourPeaks();

	double f(BinaryInstance* bi);

private:
	int headingOnes(BinaryInstance *bi);
	int tailingZeros(BinaryInstance *bi);
	int r(BinaryInstance *bi);
};
#endif
