
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)	 *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>.   	 *	
 *********************************************************************************/

#ifndef SPINGLASS_H
#define SPINGLASS_H

#include "ObjectiveFunction.h"

#define BEST_BEGIN "BEST_BEGIN"
#define BEST_END "BEST_END"
#define COUPLING_BEGIN "COUPLING_BEGIN"
#define COUPLING_END "COUPLING_END"

/* This class defines the Spin Glass objective function. */

class SpinGlass : public ObjectiveFunction {
protected: 
	class SpinCoupling {
		int _spin1;
		int _spin2; 
		int _coupling; 
		
		public:
			SpinCoupling(int spin1, int spin2, int coupling=0) : _spin1(spin1), _spin2(spin2), _coupling(coupling) {};
        		virtual ~SpinCoupling() {};
        		
        		int getSpin1() { return _spin1; }; 
        		int getSpin2() { return _spin2; };
        		int getCoupling() { return _coupling; };
	};
	
	vector<SpinCoupling*> _grid;
	double _maxFitness; 
	
public:
        SpinGlass(char* filename, int size);
        virtual ~SpinGlass();

	double f(BinaryInstance* bi);

private: 
	bool parseFile(char* filename);
};

#endif
