 
/*********************************************************************************
 *  Copyright© 2010 Gabriele Valentini (gabriele.valentini@mail.polimi.it)       *
 *                  Luigi Malagò (malago@elet.polimi.it)                         *
 *										 *
 *  This file is part of Evoptool.						 *
 * 										 *
 *  Evptool is free software: you can redistribute it and/or modify              *
 *  it under the terms of the GNU General Public License as published by         *
 *  the Free Software Foundation, either version 3 of the License, or            *
 *  (at your option) any later version.                                          *
 *										 *
 *  Evoptool is distributed in the hope that it will be useful,                  *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of  		 *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 		 *
 *  GNU General Public License for more details.				 *
 *										 *
 *  You should have received a copy of the GNU General Public License		 *
 *  along with Evoptool.  If not, see <http://www.gnu.org/licenses/>. 		 *	
 *********************************************************************************/

#ifndef UMDA_H_
#define UMDA_H_

#include "UnivariateEDA.h"

using namespace std;

/* This class defines the Univariate Model Distribution Algorithm, which is very similar to PBIL except that
 * it does not exploit any learning rule. A version of UMDA with the same learning rule of PBIL is called SUMDA, 
 * but is not implemented in this library because it is strictly equal to PBIL. */

class UMDA : public UnivariateEDA {
	public:
		UMDA(int popSize, const gsl_rng* rnd);
		virtual ~UMDA();

		void estimation();
		string getName();
};
#endif
